<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/30/2005 *
 * ===============                              Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : account.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Sponsor can manage his account                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Der Sponsor kann sein Account verwalten          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!EXT_IS_ACTIVE('sponsor')) {
	addFatalMessage(__FILE__, __LINE__, generateExtensionInactiveNotInstalledMessage('sponsor'));
	return;
} elseif (!IS_SPONSOR()) {
	// No sponsor!
	addFatalMessage(__FILE__, __LINE__, getMessage('SPONSOR_ONLY_AREA_ENTERED'));
	return;
}

// Data for the formular
$result = SQL_QUERY_ESC("SELECT `company`, `position`, `tax_ident`,
`gender`, `surname`, `family`, `street_nr1`, `street_nr2`, `zip`, `city`, `country`,
`phone`, `fax`, `cell`, `email`, `url`,
`status`, `receive_warnings`
FROM `{!_MYSQL_PREFIX!}_sponsor_data`
WHERE `id`='%s' AND `password`='%s' LIMIT 1",
	array(bigintval(getSession('sponsorid')), getSession('sponsorpass')), __FILE__, __LINE__);

// Entry found?
if (SQL_NUMROWS($result) == 1) {
	// Load sponsor data
	$content = SQL_FETCHARRAY($result);
	if ($content['status'] == 'CONFIRMED') {
		// Check if form was submitted or not
		if (isFormSent()) {
			// Check passwords
			if (!REQUEST_ISSET_POST('pass_old')) {
				// No current password entered
				$message = getMessage('SPONSOR_NO_CURRENT_PASSWORD_ENTERED');
			} elseif (md5(REQUEST_POST('pass_old')) != getSession('sponsorpass')) {
				// Entered password didn't match password in DB
				$message = getMessage('SPONSOR_CURRENT_PASSWORD_DIDNOT_MATCH_DB');
			} elseif ((REQUEST_ISSET_POST('pass1')) && (REQUEST_ISSET_POST('pass2')) && (REQUEST_POST('pass1') != REQUEST_POST('pass2'))) {
				// Both new passwords did not match
				$message = getMessage('SPONSOR_BOTH_NEW_PASSWORDS_DIDNOT_MATCH');
			} elseif ((!REQUEST_ISSET_POST('pass1')) && (REQUEST_ISSET_POST('pass2'))) {
				// No password one entered
				$message = getMessage('SPONSOR_PASSWORD_ONE_EMPTY');
			} elseif ((REQUEST_ISSET_POST('pass1')) && (!REQUEST_ISSET_POST('pass2'))) {
				// No password two entered
				$message = getMessage('SPONSOR_PASSWORD_TWO_EMPTY');
			} elseif ((REQUEST_ISSET_POST('pass1')) && (strlen(REQUEST_POST('pass1')) < getConfig('pass_len'))) {
				// Too short password
				$message = sprintf(getMessage('SPONSOR_PASSWORD_TOO_SHORT'), getConfig('pass_len'));
			} else {
				// Default is we don't want to change password!
				$PASS_AND = ''; $PASS_DATA = '';

				// Check if we want to change password or not
				if ((REQUEST_POST('pass1') == REQUEST_POST('pass2')) && (REQUEST_ISSET_POST('pass1')) && (REQUEST_POST('pass1') != REQUEST_POST('pass_old'))) {
					// Change current password
					$PASS_AND  = ", password='%s'";
					$PASS_DATA = md5(REQUEST_POST('pass1'));
				}

				// Unsecure data which we don't want here
				$UNSAFE = array('receive_warnings', 'warning_interval');

				// Remove all (maybe spoofed) unsafe data from array
				foreach ($UNSAFE as $remove) {
					REQUEST_UNSET_POST($remove);
				}

				// Set last change timestamp
				REQUEST_SET_POST('last_change', "UNIX_TIMESTAMP()");

				// Save data
				$message = SPONSOR_SAVE_DATA(REQUEST_POST_ARRAY(), $content);
			}

			if (!empty($message)) {
				// Output message
				$OUT = LOAD_TEMPLATE('admin_settings_saved', true, $message);
			} else {
				// No message generated
				$OUT = LOAD_TEMPLATE('admin_settings_saved', true, getMessage('SPONSOR_NO_MESSAGE_GENERATED'));
			}
		} else {
			// Check for gender selection
			switch ($content['gender'])
			{
				case 'M': // Male
					define('__GENDER_M', ' selected="selected"');
					define('__GENDER_F', '');
					define('__GENDER_C', '');
					break;

				case 'F': // Female
					define('__GENDER_M', '');
					define('__GENDER_F', ' selected="selected"');
					define('__GENDER_C', '');
					break;

				case 'C': // Company
					define('__GENDER_M', '');
					define('__GENDER_F', '');
					define('__GENDER_C', ' selected="selected"');
					break;
			}

			// Output formular
			$OUT = LOAD_TEMPLATE('sponsor_account_form', true, $content);
		}
	} else {
		// Locked or so?
		$STATUS = sponsorTranslateUserStatus($content['status']);
		$OUT = LOAD_TEMPLATE('admin_settings_saved', true, sprintf(getMessage('SPONSOR_ACCOUNT_FAILED'), $STATUS));
	}
} else {
	// Sponsor account not found!
	$OUT = LOAD_TEMPLATE('admin_settings_saved', true, sprintf(getMessage('SPONSOR_ACCOUNT_404'), getSession('sponsorid')));
}

// Free memory
SQL_FREERESULT($result);

//
?>
